﻿--	--	--	--	--	--	--	--	--
--		Action handler			--
--								--
--	handles the actions			--
--	--	--	--	--	--	--	--	--
function MLC_Action(Action, x, y, Time)	--time is in seconds
	if MLC_DB["Quick"] then Time = 3 end
	local point, relativeTo, relativePoint, xOfs, yOfs = MLC_AnimatedPonyBox:GetPoint()
	local CurrentPony = MLC_DB["Pony"];
	
	MLC_LastAction = Action;
	
	if Time == nil then
		Time = 5;
	end
	
	if x== nil or y == nil then
		x = xOfs;
		y = yOfs;
	end
	
	local xtravel = x-xOfs;
	local ytravel = y-yOfs;
	
	local maxtravel = max( abs(xtravel),  abs(ytravel));	-- find the max amount we wil travel
	
	if maxtravel < 50 and Action == "Walk" then	--if we are not travelling far (only if not idle)
		Time = Time * maxtravel / 50;
	end
	
	if xtravel > 0 then
		MLC_AnimationDirection = "Right";
	elseif xtravel < 0 then
		MLC_AnimationDirection = "Left";
	end
	
	if CurrentPony == "RainbowDash" then	-- fly fast handler for rainbow dash
		if Action == "Fight" then
			Action = "Idle";
		end
			
		if Action == "Walk" then
			if random(5) == 1 then
				Time = Time/2;	-- 20% chance to move at 2x speed
			end
			
			if	abs((xtravel)/Time) > 200 or abs((xtravel)/Time) > 200 then
				Action = "Flyfast"
			end
		end
	end
	
	if CurrentPony == "Fluttershy" then	-- combat handler for ponies with combat animations
		if UnitAffectingCombat("player") then
			if random(5) == 1 then
				Action = "Fight";
				x = xOfs;
				y = yOfs;
				Time = 2;
			end
		end
	end
	
	MaxID = #MLC_AnimationData[CurrentPony][Action];	-- the amount of ID's we have (different walks/stands/etc...)
	ActionID = random(MaxID);
	
	local row,start,amount,total_amount,size;
	
	--	1		2		3					4					5		6
	-- 	row, 	start, 	animation_amount, 	total_amount,  		size, 	delay_(ms)
	MLC_AnimatedPonyIndexY	= MLC_AnimationData[CurrentPony][Action][ActionID][1];
	start 		 			= MLC_AnimationData[CurrentPony][Action][ActionID][2];	--the data about the 
	amount  	 			= MLC_AnimationData[CurrentPony][Action][ActionID][3];	--animation
	MLC_TotalAmtSprites 	= MLC_AnimationData[CurrentPony][Action][ActionID][4];
	MLC_AnimatedPonySize 	= MLC_AnimationData[CurrentPony][Action][ActionID][5];	-- the length of the sprite
	MLC_IdleTime 			= MLC_AnimationData[CurrentPony][Action][ActionID][6] / 1000;

	MLC_AnimatedPonyIndexMin = start;
	MLC_AnimatedPonyIndexMax = start+amount-1;
	
	MLC_AnimatedPonyIndex = MLC_AnimatedPonyIndexMin;
	MLC_AnimatedPonyLastUpdateTime = GetTime()-10;
	
	MLC_AnimatedPonyStartX = xOfs;
	MLC_AnimatedPonyStartY = yOfs;
	MLC_AnimatedPonyDestinationX = x;
	MLC_AnimatedPonyDestinationY = y;
	MLC_AnimatedPonyTravelTime = Time;
	MLC_AnimatedPonyDestinationTime = GetTime() + Time;
	MLC_AnimatedPonyActionTime = GetTime() + 999;
	MLC_DestinationHandler:Show();
end



--	--	--	--	--	--	--	--	--
--		Autoupdate for the 		--
--	pick a random spot function	--
--								--
--	--	--	--	--	--	--	--	--
--MLC_OnDeathFrame = CreateFrame("FRAME")
--MLC_OnDeathFrame:RegisterEvent("PLAYER_DEAD");
--MLC_OnDeathFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
--MLC_OnDeathFrame:SetScript("OnEvent", function() 
--	MLC_Action("Dazed", 0, 0, 30)
--end)

MLC_OnCombatFrame = CreateFrame("FRAME")
MLC_OnCombatFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
MLC_OnCombatFrame:SetScript("OnEvent", function() 
	MLC_Action("Fight", nil, nil, 2)
end)

function FIM_AnimationTimeoutHandler()
	
	if MLC_LastAction == "Idle" then
		local x = MLC_CharacterBox:GetWidth() - 100;
		local y = MLC_CharacterBox:GetHeight() - 100;
		
		local gotox = random(x);
		local gotoy = random(y);
		
		local Time = random(4)+1;

		MLC_Action("Walk", (gotox-(x/2)), (gotoy-(y/2)), Time)	-- Action, x, y, Time (seconds)
	elseif MLC_LastAction == "Walk" then
		local Time = random(15)+5;
		
		MLC_Action("Idle", nil, nil, Time)	-- Action, x, y, Time (seconds)
	elseif MLC_LastAction == "Fight" then
		local Time = random(7)+3;
		
		MLC_Action("Idle", nil, nil, Time)	-- Action, x, y, Time (seconds)
	else
		local Time = random(3)+2;
		
		MLC_Action("Idle", nil, nil, Time)	-- Action, x, y, Time (seconds)
	end
end